; game main program
;
(define (reset-all)
  (restore-io2) (echo) (cursor-visible) (system "xset r"))
;
(define (weapon)
  (let
      ((by   0)
       (bx   0)
       (mark 'off)
       (bom  '())
       (draw  '())
       (w-mv  '()))
    (define (up!)   (set! by (- by 1)))
    (define (down!) (set! by (+ by 1)))
;
    (define (dispatch m . arg)
      (cond
       ((eq? m 'set)
	(cond
	 ((eq? (car arg) 'beam) (set! bom #\i) (set! draw to->red) (set! w-mv up!))
	 ((eq? (car arg) 'bomb) (set! bom #\O) (set! draw to->yellow) (set! w-mv down!))
	 (else (reset-all) (display "ERR:command in weapon") (newline) (exit))))
       ((eq? m 'on!) (set! by (car arg)) (set! bx (cadr arg)) (set! mark 'on))
       ((eq? m 'off!) (set! mark 'off))
       ((eq? m 'line) by)
       ((eq? m 'col)  bx)
       ((eq? m 'setline!) (set! by (car arg)))
       ((eq? m 'mark) mark)
       ((eq? m 'move!) (w-mv))
       ((eq? m 'show) (draw) (mvaddch by bx bom) (to->normal))
       ((eq? m 'space) (mvaddch by bx #\space))))
    dispatch))
;
(define (army)
  (let
      ((ay  0)
       (ax  0)
       (prt #\A))
;
    (define (dispatch m . arg)
      (cond
       ((eq? m 'set) (set! ay (car arg)) (set! ax (cadr arg)))
       ((eq? m 'right!) (set! ax (+ ax 1)))
       ((eq? m 'left!)  (set! ax (- ax 1)))
       ((eq? m 'space) (mvaddch ay ax #\space))
       ((eq? m 'show)  (mvaddch ay ax prt) #t)
       ((eq? m 'crush) (to->red) (mvaddstr ay (- ax 1) "XXX") (to->normal))
       ((eq? m 'line)    ay)
       ((eq? m 'col)     ax)))
;
    dispatch))
;
;
(define (enemy)
  (let
      ((ay  0)
       (ax  0)
       (mv-drv '())
       (count 0))
    (define (space)    (mvaddch ay ax #\space))
    (define (show)     (mvaddch ay ax #\O))
    (define (left-drv)  (set! ax (- ax 1)))
    (define (right-drv) (set! ax (+ ax 1)))
    (define (walk!)
      (let
	  ((tmp  0))
	(set! tmp (mk-random 200))
	(if (> tmp 100) (set! mv-drv left-drv) (set! mv-drv right-drv))
	(set! tmp (mk-random 100))
	(cond
	 ((>= tmp 80) (set! count 12))
	 ((and (>= tmp 60) (< tmp 80)) (set! count 10))
	 ((and (>= tmp 40) (< tmp 60)) (set! count  8))
	 ((and (>= tmp 20) (< tmp 40)) (set! count  6))
	 (else (set! count 4)))
	(set! tmp (mk-random 60))
	(set! ax (+ tmp 10))
	(show)))
    (define (get-opr) (if (eq? mv-drv left-drv) - +))
;    
    (define (dispatch m . arg)
      (cond
       ((eq? m 'set)      (set! ay (car arg)) (set! ax (cadr arg)))
       ((eq? m 'col)      ax)
       ((eq? m 'line)     ay)
       ((eq? m 'space)    (space))
       ((eq? m 'show)     (show))
       ((eq? m 'hide!)    (set! count 0) (space))
       ((eq? m 'walk!)    (walk!))
       ((eq? m 'count0?)  (= count 0))
       ((eq? m 'count--!) (and (> count 0) (set! count (- count 1))))
       ((eq? m 'hide?)    (= count 0))
       ((eq? m 'move!)    (mv-drv))
       ((eq? m 'get-opr)  (get-opr))
       ((eq? m 'crush)    (to->red) (mvaddstr ay (- ax 1) "XXX") (to->normal))
       (else (display "ERR:command in enemy") (newline) #f)))
;    
    dispatch))
;
;
;       
;
;
(define (weapon-grp)
  (let
      ((seed     '())
       (num       0))
;
    (define (init t)
      (let
	  ((tmp '()))
	(cond
	 ((eq? t 'beam) (set! num $$n))
	 ((eq? t 'bomb) (set! num $$m)))
	(set! seed (make-vector num '()))
	(do
	    ((i 0 (+ i 1)))
	    ((= i num) #t)
	  (set! tmp (weapon))
	  (vector-set! seed i tmp)
	  (tmp 'off)
	  (cond
	   ((eq? t 'beam)
	    (tmp 'set 'beam)
	    (tmp 'setline! $my-line))
	   ((eq? t 'bomb)
	    (tmp 'set 'bomb)
	    (tmp 'setline! $ene-line))
	   (else (display "ERR:command in weapon grp") (newline) #f)))))
;
    (define (on! n y x)   ((vector-ref seed n) 'on! y x))
    (define (off! n)  ((vector-ref seed n) 'off!))
    (define (line n) ((vector-ref seed n) 'line))
    (define (col n)  ((vector-ref seed n) 'col))
    (define (mark n) ((vector-ref seed n) 'mark))
    (define (move! n) ((vector-ref seed n) 'move!))
    (define (show n) ((vector-ref seed n) 'show))
    (define (space n) ((vector-ref seed n) 'space))
;
    (define (get-low)
      (let
	  ((low $ene-line)
	   (tmp $ene-line))
	(do
	    ((i 0 (+ i 1)))
	    ((= i num) low)
	  (if (eq? (mark i) 'on)
	      (begin (set! tmp (line i))
		     (if (> tmp low) (set! low tmp)))))))
;
    (define (can-shoot-beam)
      (let
	  ((que   (que-std))
	   ($line (get-low)))
	(do
	    ((i 0 (+ i 1)))
	    ((= i num) que)
	  (if (and (<= $line $beam-line) (eq? (mark i) 'off)) (que 'inque! i)))))
;
    (define (get-high)
      (let
	  ((high $my-line)
	   (tmp  $my-line))
	(do
	    ((i 0 (+ i 1)))
	    ((= i num) high)
	  (if (eq? (mark i) 'on)
	      (begin (set! tmp (line i))
		     (if (< tmp high) (set! high tmp)))))))
;
    (define (can-shoot-bomb)
      (let
	  ((que   (que-std))
	   ($line (get-high)))
	(que 'clear!)
	(do
	    ((i 0 (+ i 1)))
	    ((= i num) que)
	  (if (and (>= $line $bomb-line) (eq? (mark i) 'off)) (que 'inque! i)))))
;
    (define (dispatch m . arg)
      (cond
       ((eq? m 'init)   (init (car arg)))
       ((eq? m 'on!)    (on!    (car arg) (cadr arg) (caddr arg)))
       ((eq? m 'off!)   (off!   (car arg)))
       ((eq? m 'line)   (line  (car arg)))
       ((eq? m 'col)    (col   (car arg)))
       ((eq? m 'mark)   (mark  (car arg)))
       ((eq? m 'move!)  (move!  (car arg)))
       ((eq? m 'can-shoot-beam) (can-shoot-beam))
       ((eq? m 'can-shoot-bomb) (can-shoot-bomb))
       ((eq? m 'show)   (show  (car arg)))
       ((eq? m 'space)  (space (car arg)))
;	
       (else (display "ERR:command in weapon-grp") (newline) (reset-all) #f)))
;
    dispatch))
;
(define $ene-line 3)
(define $ene-col  9)
(define $my-line 20)
(define $my-col  10)
;
;
(define $$n 3)
(define $beam-line (- $my-line (floor (/ (- $my-line $ene-line) $$n))))
(define $$m 20)
(define $bomb-line (+ $ene-line (floor (/ (- $my-line $ene-line) $$m))))
;
(define $l-limit   5)
(define $r-limit  78)
(define $wait1  0.2)
(define $wait2  0.3)
(define $wait3  1.3)
(define $wait4  0.7)
;
;
;
(define (game)
  (let
      ((m  0)
       (bb    (weapon-grp))
       (bom   (weapon-grp))
       (bwt   (stop-watch))
       (h-wt  (stop-watch))
       (bo-wt (stop-watch))
       (me    (army))
       (him   (enemy))
       ($canshoot-beam #f)
       ($canshoot-bomb #f)
       ($stop-mark   'go)
       (tmp    0))
;
    (reset-init-state)
    (setting2)
    (noecho)
    (cursor-invisible)
    (bb  'init 'beam)
    (bom 'init 'bomb)
    (bwt 'set)
    (h-wt 'set)
    (bo-wt 'set)
    (me  'set $my-line $my-col)
    (him 'set $ene-line $ene-col)
    (him 'walk!)
    (system "xset -r")
;
    (do
	((m (getch2) (getch2)))
	((or (and (char? m) (char=? m #\q)) (eq? $stop-mark 'stop))
	 (reset-all) (reset-init-state))
;
      (cond
       ((and (char? m) (char=? m #\j))
	(me 'space) (me 'left!))
       ((and (char? m) (char=? m #\l))
	(me 'space) (me 'right!))
       ((and (char? m) (char=? m #\space))
	(set! $canshoot-beam (bb 'can-shoot-beam))
	(if (not ($canshoot-beam 'isempty?))
	    (bb 'on! ($canshoot-beam 'outque!) (me 'line) (me 'col)))))

;
      (if (> (bo-wt 'get) $wait4)
	  (begin
	    (set! $canshoot-bomb (bom 'can-shoot-bomb))
	    (if (not ($canshoot-bomb 'isempty?))
		(bom 'on! ($canshoot-bomb 'outque!) (+ (him 'line) 2) ((him 'get-opr) (him 'col) 5)))
	    (bo-wt 'set)))

;
      (if (> (bwt 'get) $wait1)
	  (begin
	    (do
		((i 0 (+ i 1)))
		((= i $$n) #t)
	      (if (eq? (bb 'mark i) 'on)
		  (begin
		    (bb 'space i)
		    (bb 'move! i)
		    (bb 'show i)))
	      (if (and (eq? (bb 'mark i) 'on) (< (bb 'line i) $ene-line))
		  (begin
		    (bb 'space i)
		    (bb 'off! i)
		    (if (= (bb 'col i) (him 'col))
			(begin
			  (him 'crush)
			  (system "sleep 3")
			  (set! $stop-mark 'stop))))))
;
	    (do
		((i 0 (+ i 1)))
		((= i $$m) #t)
	      (if (eq? (bom 'mark i) 'on)
		  (begin
		    (bom 'space i)
		    (bom 'move! i)
		    (bom 'show i)))
	      (if (and (eq? (bom 'mark i) 'on) (> (bom 'line i) $my-line))
		  (begin
		    (bom 'space i)
		    (bom 'off! i)
		    (if (= (bom 'col i) (me 'col))
			(begin
			  (me 'crush)
			  (system "sleep 3")
			  (set! $stop-mark 'stop))))))
;
	    (bwt 'set)))
;
;
      (cond
       ((him 'hide?) (if (>= (h-wt 'get) $wait3)
			 (begin (h-wt 'set)
				(him 'walk!))))
       (else
	(if (or	(<= (him 'col) $l-limit)
		(>= (him 'col) $r-limit))
	    (begin (him 'space) (him 'hide!) (h-wt 'set))
	    (if (>= (h-wt 'get) $wait2)
		(begin (him 'space)
		       (him 'move!)
		       (him 'show)
		       (him 'count--!)
		       (if (him 'count0?)
			   (begin (him 'space) (him 'hide!)))
		       (h-wt 'set))))))
;
;
      (me 'show))))
;
