;
; needs headerfile
;
(define (write-2nums n m)
  (write-char #\esc)
  (write-char #\[)
  (display (number->string n))
  (write-char #\;)
  (display (number->string m)))
;
(define (write-1num n)
  (write-char #\esc)
  (write-char #\[)
  (display (number->string n)))
;
(define (esc-str str)
  (write-char #\esc)
  (display str))
;
(define (esc-char c)
  (write-char #\esc)
  (write-char c))
;
(define (cursor-move direct num)
  (write-1num num)
  (cond
   ((eq? direct 'up)    (write-char #\A))
   ((eq? direct 'down)  (write-char #\B))
   ((eq? direct 'right) (write-char #\C))
   ((eq? direct 'left)  (write-char #\D))))
;
; *************************** use bellow *****************************
;
(define (cursor-u n) (cursor-move 'up n))
(define (cursor-d n) (cursor-move 'down n))
(define (cursor-r n) (cursor-move 'right n))
(define (cursor-l n) (cursor-move 'left n))
;
(define (cursor-position n m) (write-2nums n m) (write-char #\H))
;
(define (save-cursor)   (esc-char (integer->char 7)))
(define (restor-cursor) (esc-char (integer->char 8)))
;
;
(define (erase-disp n) (write-1num n) (write-char #\J))
(define (erase-disp-top-to-cursor) (erase-disp 1))
(define (erase-disp-all)           (erase-disp 2))
(define (erase-disp-cursor-to-end) (erase-disp 0))
;
(define (erase-line n) (write-1num n) (write-char #\K))
(define (erase-line-top-to-cursor) (erase-line 1))
(define (erase-line-all)           (erase-line 2))
(define (erase-line-cursor-to-end) (erase-line 0))
;
(define (cursor-index)     (esc-char #\D))
(define (cursor-nextline)  (esc-char #\E))
(define (cursor-rev-index) (esc-char #\M))
;
(define (set-margins $from $to) (write-2nums $from $to) (write-char #\r))
; margin is from $from to $to.
; start-1 end-24. standard tty is 24 lines.
;
(define (reset-init-state)  (esc-char #\c))
;
(define (to->red)    (write-1num 31) (write-char #\m))
(define (to->yellow) (write-1num 33) (write-char #\m))
(define (to->blue)   (write-1num 34) (write-char #\m))
(define (to->normal) (write-1num 0)  (write-char #\m))
(define (to->bg-blue) (write-1num 44) (write-char #\m))
(define (to->bg-black) (write-1num 40) (write-char #\m))
;
(define (full-e) (esc-str "#8"))
;
(define (char-dim) (write-1num 2) (write-char #\m))
(define (char-ul)  (write-1num 4) (write-char #\m))
(define (char-blink) (write-1num 5) (write-char #\m))
(define (char-rev) (write-1num 7) (write-char #\m))
(define (char-hide) (write-1num 8) (write-char #\m))
(define (char-deny) (write-1num 9) (write-char #\m))
;
;
; *** for FreeBSD ****
(define (cursor-invisible) (system "tput vi"))
(define (cursor-visible) (system "tput vs"))
;
; *** for Linux   ****
;(define (cursor-invisible) (system "tput cnorm"))
;(define (cursor-visible)   (system "tput civis"))
;
; ********************
;
; *** from stty command of unix's ***
(define (echo) (system "stty echo"))
(define (noecho) (system "stty -echo"))
(define (cbreak) (system "stty cbreak"))
(define (nocbreak) (system "stty -cbreak"))
;
(define (mvaddch n m $char) (cursor-position n m) (write-char $char))
(define (mvaddstr n m $str) (cursor-position n m) (write      $str))
(define (mvgetch n m)       (cursor-position n m) (read-char))
(define (mvgetstr n m)      (cursor-position n m) (read-line))
;







